# To unbundle, "sed '1,/^# To unbundle/d' < thisfile | sh"
# Mon Sep 23 16:01:31 EDT 1991
echo list.c 1>&2
sed 's/^-//' >'list.c' <<'End of list.c'
-/* 
- * $Source: /a/thud/chalk/homes/moore/src/hence/master/librb/RCS/rb.sh,v $
- * $Revision: 1.1 $
- * $Date: 1992/04/08 05:53:02 $
- * $Author: moore $
- */
-
-#include <stdio.h>    /* Basic includes and definitions */
-#include "list.h"
-
-#define boolean int
-#define TRUE 1
-#define FALSE 0
-
-
-/*---------------------------------------------------------------------*
- * PROCEDURES FOR MANIPULATING DOUBLY LINKED LISTS 
- * Each list contains a sentinal node, so that     
- * the first item in list l is l->flink.  If l is  
- * empty, then l->flink = l->blink = l.            
- * The sentinal contains extra information so that these operations
- * can work on lists of any size and type.
- * Memory management is done explicitly to avoid the slowness of
- * malloc and free.  The node size and the free list are contained
- * in the sentinal node.
- *---------------------------------------------------------------------*/
-
-typedef struct int_list {  /* Information held in the sentinal node */
-  struct int_list *flink;
-  struct int_list *blink;
-  int size;
-  List free_list;
-} *Int_list;
-
-insert(item, list)	/* Inserts to the end of a list */
-List item;
-List list;
-{
-  List last_node;
-
-  last_node = list->blink;
-
-  list->blink = item;
-  last_node->flink = item;
-  item->blink = last_node;
-  item->flink = list;
-}
-
-delete_item(item)		/* Deletes an arbitrary iterm */
-List item;
-{
-  item->flink->blink = item->blink;
-  item->blink->flink = item->flink;
-}
-
-List make_list(size)	/* Creates a new list */
-int size;
-{
-  Int_list l;
-
-  l = (Int_list) malloc(sizeof(struct int_list));
-  l->flink = l;
-  l->blink = l;
-  l->size = size;
-  l->free_list = (List) malloc (sizeof(struct list));
-  l->free_list->flink = l->free_list;
-  return (List) l;
-}
-  
-List get_node(list)   /* Allocates a node to be inserted into the list */
-List list;
-{
-  Int_list l;
-  List to_return;
-
-  l = (Int_list) list;
-  if (l->free_list->flink == l->free_list) {
-    return (List) malloc(l->size);
-  } else {
-    to_return = l->free_list;
-    l->free_list = to_return->flink;
-    return to_return;
-  }
-}
-
-free_node(node, list)    /* Deallocates a node from the list */
-List node;
-List list;
-{
-  Int_list l;
-  
-  l = (Int_list) list;
-  node->flink = l->free_list;
-  l->free_list = node;
-}
End of list.c
echo main.c 1>&2
sed 's/^-//' >'main.c' <<'End of main.c'
-#include "rb.h"
-#include <stdio.h>
-
-/* an example -- this allocates a red-black tree for integers.  For a 
- * user-specified number of iterations, it does the following:
-
- * delete a random element in the tree.
- * make two new random elements, and insert them into the tree
- 
- * At the end, it prints the sorted list of elements, and then prints
- * stats of the number of black nodes in any path in the tree, and 
- * the minimum and maximum path lengths.
-  
- * Rb_find_ikey and rb_inserti could have been used, but instead
- * rb_find_gkey and rb_insertg were used to show how they work.
-  
- */
-
-int icomp(i, j)
-int i, j;
-{
-  if (i == j) return 0;
-  if (i > j) return -1; else return 1;
-}
-
-main(argc, argv)
-int argc;
-char **argv;
-{
-  int i, j, tb, nb, mxp, mnp, p;
-  int iterations;
-  Rb_node argt, t;
-  int *a;
-
-  if (argc != 2) {
-    fprintf(stderr, "usage: main #iterations\n");
-    exit(1);
-  }
-  argt = make_rb();
-  srandom(time(0));
-  iterations = atoi(argv[1]);
-  a = (int *) malloc (iterations*sizeof(int));
-
-  for (i = 0; i < atoi(argv[1]); i++) {
-    if (i > 0) {
-      j = random()%i;
-      
-      rb_delete_node(rb_find_gkey(argt, a[j], icomp));
-      a[j] = random() % 1000;
-      rb_insertg(argt, a[j], 0, icomp);
-    }
-    a[i] = random() % 1000;
-    rb_insertg(argt, a[i], 0, icomp);
-  }
-  tb = 0;
-  mxp = 0;
-  mnp = 0;
-  for (t = rb_first(argt); t != nil(argt); t = rb_next(t)) {
-    printf("%d ", t->k.ikey);
-    nb = rb_nblack(t);
-    p = rb_plength(t);
-    if (tb == 0) {
-      tb = nb;
-    } else if (tb != nb) {
-      printf("Conflict: tb=%d, nb=%d\n", tb, nb);
-      exit(1);
-    }
-    mxp = (mxp == 0 || mxp < p) ? p : mxp;
-    mnp = (mnp == 0 || mxp > p) ? p : mnp;
-  }
-  printf("\n");  
-
-  printf("Nblack = %d\n", tb);
-  printf("Max    = %d\n", mxp);
-  printf("Min    = %d\n", mnp);
-}
End of main.c
echo rb.c 1>&2
sed 's/^-//' >'rb.c' <<'End of rb.c'
-#include "rb.h"
-#include <stdio.h>
-
-#define isred(n) (n->s.red)
-#define isblack(n) (!isred(n))
-#define isleft(n) (n->s.left)
-#define isright(n) (!isleft(n))
-#define isint(n) (n->s.internal)
-#define isext(n) (!isint(n))
-#define ishead(n) (n->s.head)
-#define isroot(n) (n->s.root)
-#define setred(n) n->s.red = 1
-#define setblack(n) n->s.red = 0
-#define setleft(n) n->s.left = 1
-#define setright(n) n->s.left = 0
-#define sethead(n) n->s.head = 1
-#define setroot(n) n->s.root = 1
-#define setint(n) n->s.internal = 1
-#define setext(n) n->s.internal = 0
-#define setnormal(n) { n->s.root = 0; n ->s.head = 0; }
-#define sibling(n) ((isleft(n)) ? n->p.parent->c.child.right \
-                                : n->p.parent->c.child.left)
-
-#define mk_new_ext(new, kkkey, vvval) {\
-  new = (Rb_node) malloc(sizeof(struct rb_node));\
-  new->v.val = vvval;\
-  new->k.key = kkkey;\
-  setext(new);\
-  setblack(new);\
-  setnormal(new);\
-}
-
-mk_new_int(l, r, p, il)
-Rb_node l, r, p;
-int il;
-{
-  Rb_node new;
-
-  new = (Rb_node) malloc(sizeof(struct rb_node));
-  setint(new);
-  setred(new);
-  setnormal(new);
-  new->c.child.left = l;
-  new->c.child.right = r;
-  new->p.parent = p;
-  new->k.lext = l;
-  new->v.rext = r;
-  l->p.parent = new;
-  r->p.parent = new;
-  setleft(l);
-  setright(r);
-  if (ishead(p)) {
-    p->p.root = new;
-    setroot(new);
-  } else if (il) {
-    setleft(new);
-    p->c.child.left = new;
-  } else {
-    setright(new);
-    p->c.child.right = new;
-  }
-  recolor(new);
-}  
-  
-   
-Rb_node lprev(n)
-Rb_node n;
-{
-  if (ishead(n)) return n;
-  while (!isroot(n)) {
-    if (isright(n)) return n->p.parent;
-    n = n->p.parent;
-  }
-  return n->p.parent;
-}
-
-Rb_node rprev(n)
-Rb_node n;
-{
-  if (ishead(n)) return n;
-  while (!isroot(n)) {
-    if (isleft(n)) return n->p.parent;
-    n = n->p.parent;
-  }
-  return n->p.parent;
-}
-
-Rb_node make_rb()
-{
-  Rb_node head;
-
-  head = (Rb_node) malloc (sizeof(struct rb_node));
-  head->c.list.flink = head;
-  head->c.list.blink = head;
-  head->p.root = head;
-  head->k.key = "";
-  sethead(head);
-  return head;
-}
-
-Rb_node rb_find_key_n(n, key, fnd)
-Rb_node n;
-char *key;
-int *fnd;
-{
-  int cmp;
-
-  *fnd = 0;
-  if (!ishead(n)) {
-    fprintf(stderr, "rb_find_key_n called on non-head 0x%x\n", n);
-    exit(1);
-  }
-  if (n->p.root == n) return n;
-  cmp = strcmp(key, n->c.list.blink->k.key);
-  if (cmp == 0) {
-    *fnd = 1;
-    return n->c.list.blink; 
-  }
-  if (cmp > 0) return n; 
-  else n = n->p.root;
-  while (1) {
-    if (isext(n)) return n;
-    cmp = strcmp(key, n->k.lext->k.key);
-    if (cmp == 0) {
-      *fnd = 1;
-      return n->k.lext;
-    }
-    if (cmp < 0) n = n->c.child.left ; else n = n->c.child.right;
-  }
-}
-
-Rb_node rb_find_key(n, key)
-Rb_node n;
-char *key;
-{
-  int fnd;
-  return rb_find_key_n(n, key, &fnd);
-}
-
-Rb_node rb_find_ikey_n(n, ikey, fnd)
-Rb_node n;
-int ikey;
-int *fnd;
-{
-  *fnd = 0;
-  if (!ishead(n)) {
-    fprintf(stderr, "rb_find_ikey_n called on non-head 0x%x\n", n);
-    exit(1);
-  }
-  if (n->p.root == n) return n;
-  if (ikey == n->c.list.blink->k.ikey) {
-    *fnd = 1;
-    return n->c.list.blink; 
-  }
-  if (ikey > n->c.list.blink->k.ikey) return n; 
-  else n = n->p.root;
-  while (1) {
-    if (isext(n)) return n;
-    if (ikey == n->k.lext->k.ikey) {
-      *fnd = 1;
-      return n->k.lext;
-    }
-    n = (ikey < n->k.lext->k.ikey) ? n->c.child.left : n->c.child.right;
-  }
-}
-
-Rb_node rb_find_ikey(n, ikey)
-Rb_node n;
-int ikey;
-{
-  int fnd;
-  return rb_find_ikey_n(n, ikey, &fnd);
-}
-
-Rb_node rb_find_gkey_n(n, key, fxn, fnd)
-Rb_node n;
-char *key;
-int (*fxn)();
-int *fnd;
-{
-  int cmp;
-
-  *fnd = 0;
-  if (!ishead(n)) {
-    fprintf(stderr, "rb_find_key_n called on non-head 0x%x\n", n);
-    exit(1);
-  }
-  if (n->p.root == n) return n;
-  cmp = (*fxn)(key, n->c.list.blink->k.key);
-  if (cmp == 0) {
-    *fnd = 1;
-    return n->c.list.blink; 
-  }
-  if (cmp > 0) return n; 
-  else n = n->p.root;
-  while (1) {
-    if (isext(n)) return n;
-    cmp = (*fxn)(key, n->k.lext->k.key);
-    if (cmp == 0) {
-      *fnd = 1;
-      return n->k.lext;
-    }
-    if (cmp < 0) n = n->c.child.left ; else n = n->c.child.right;
-  }
-}
-
-Rb_node rb_find_gkey(n, key, fxn)
-Rb_node n;
-char *key;
-int (*fxn)();
-{
-  int *fnd;
-  return rb_find_gkey_n(n, key, fxn, &fnd);
-}
-Rb_node rb_insert_b(n, key, val)
-Rb_node n;
-char *key;
-char *val;
-{
-  Rb_node newleft, newright, newnode, list, p;
-
-  if (ishead(n)) {
-    if (n->p.root == n) {         /* Tree is empty */
-      mk_new_ext(newnode, key, val);
-      insert(newnode, n);
-      n->p.root = newnode;
-      newnode->p.parent = n;
-      setroot(newnode);
-      return newnode;
-    } else {
-      mk_new_ext(newright, key, val);
-      insert(newright, n);
-      newleft = newright->c.list.blink;
-      setnormal(newleft);
-      mk_new_int(newleft, newright, newleft->p.parent, isleft(newleft));
-      p = rprev(newright);
-      if (!ishead(p)) p->k.lext = newright;
-      return newright;
-    }
-  } else {
-    mk_new_ext(newleft, key, val);
-    insert(newleft, n);
-    setnormal(n);
-    mk_new_int(newleft, n, n->p.parent, isleft(n));
-    p = lprev(newleft);
-    if (!ishead(p)) p->v.rext = newleft;
-    return newleft;    
-  }
-}
-
-recolor(n)
-Rb_node n;
-{  
-  Rb_node p, gp, s;
-  int done = 0;
-
-  while(!done) {
-    if (isroot(n)) {
-      setblack(n);
-      return;
-    }
-
-    p = n->p.parent;
-
-    if (isblack(p)) return;
-    
-    if (isroot(p)) {
-      setblack(p);
-      return;
-    }
-
-    gp = p->p.parent;
-    s = sibling(p);
-    if (isred(s)) {
-      setblack(p);
-      setred(gp);
-      setblack(s);
-      n = gp;
-    } else {
-      done = 1;
-    }
-  }
-  /* p's sibling is black, p is red, gp is black */
-  
-  if ((isleft(n) == 0) == (isleft(p) == 0)) {
-    single_rotate(gp, isleft(n));
-    setblack(p);
-    setred(gp);
-  } else {
-    single_rotate(p, isleft(n));
-    single_rotate(gp, isleft(n));
-    setblack(n);
-    setred(gp);
-  }
-}
-
-single_rotate(y, l)
-Rb_node y;
-int l;
-{
-  int rl, ir;
-  Rb_node x, yp;
-  char *tmp;
-
-  ir = isroot(y);
-  yp = y->p.parent;
-  if (!ir) {
-    rl = isleft(y);
-  }
-  
-  if (l) {
-    x = y->c.child.left;
-    y->c.child.left = x->c.child.right;
-    setleft(y->c.child.left);
-    y->c.child.left->p.parent = y;
-    x->c.child.right = y;
-    setright(y);  
-  } else {
-    x = y->c.child.right;
-    y->c.child.right = x->c.child.left;
-    setright(y->c.child.right);
-    y->c.child.right->p.parent = y;
-    x->c.child.left = y;
-    setleft(y);  
-  }
-
-  x->p.parent = yp;
-  y->p.parent = x;
-  if (ir) {
-    yp->p.root = x;
-    setnormal(y);
-    setroot(x);
-  } else {
-    if (rl) {
-      yp->c.child.left = x;
-      setleft(x);
-    } else {
-      yp->c.child.right = x;
-      setright(x);
-    }
-  }
-}
-    
-rb_delete_node(n)
-Rb_node n;
-{
-  Rb_node s, p, gp;
-  char ir;
-
-  if (isint(n)) {
-    fprintf(stderr, "Cannot delete an internal node: 0x%x\n", n);
-    exit(1);
-  }
-  if (ishead(n)) {
-    fprintf(stderr, "Cannot delete the head of an rb_tree: 0x%x\n", n);
-    exit(1);
-  }
-  delete_item(n); /* Delete it from the list */
-  p = n->p.parent;  /* The only node */
-  if (isroot(n)) {
-    p->p.root = p;
-    free(n);
-    return;
-  } 
-  s = sibling(n);    /* The only node after deletion */
-  if (isroot(p)) {
-    s->p.parent = p->p.parent;
-    s->p.parent->p.root = s;
-    setroot(s);
-    free(p);
-    free(n);
-    return;
-  }
-  gp = p->p.parent;  /* Set parent to sibling */
-  s->p.parent = gp;
-  if (isleft(p)) {
-    gp->c.child.left = s;
-    setleft(s);
-  } else {
-    gp->c.child.right = s;
-    setright(s);
-  }
-  ir = isred(p);
-  free(p);
-  free(n);
-  
-  if (isext(s)) {      /* Update proper rext and lext values */
-    p = lprev(s); 
-    if (!ishead(p)) p->v.rext = s;
-    p = rprev(s);
-    if (!ishead(p)) p->k.lext = s;
-  } else if (isblack(s)) {
-    fprintf(stderr, "DELETION PROB -- sib is black, internal\n");
-    exit(1);
-  } else {
-    p = lprev(s);
-    if (!ishead(p)) p->v.rext = s->c.child.left;
-    p = rprev(s);
-    if (!ishead(p)) p->k.lext = s->c.child.right;
-    setblack(s);
-    return;
-  }
-
-  if (ir) return;
-
-  /* Recolor */
-  
-  n = s;
-  p = n->p.parent;
-  s = sibling(n);
-  while(isblack(p) && isblack(s) && isint(s) && 
-        isblack(s->c.child.left) && isblack(s->c.child.right)) {
-    setred(s);
-    n = p;
-    if (isroot(n)) return;
-    p = n->p.parent;
-    s = sibling(n);
-  }
-  
-  if (isblack(p) && isred(s)) {  /* Rotation 2.3b */
-    single_rotate(p, isright(n));
-    setred(p);
-    setblack(s);
-    s = sibling(n);
-  }
-    
-  { Rb_node x, z; char il;
-    
-    if (isext(s)) {
-      fprintf(stderr, "DELETION ERROR: sibling not internal\n");
-      exit(1);
-    }
-
-    il = isleft(n);
-    x = il ? s->c.child.left : s->c.child.right ;
-    z = sibling(x);
-
-    if (isred(z)) {  /* Rotation 2.3f */
-      single_rotate(p, !il);
-      setblack(z);
-      if (isred(p)) setred(s); else setblack(s);
-      setblack(p);
-    } else if (isblack(x)) {   /* Recoloring only (2.3c) */
-      if (isred(s) || isblack(p)) {
-        fprintf(stderr, "DELETION ERROR: 2.3c not quite right\n");
-        exit(1);
-      }
-      setblack(p);
-      setred(s);
-      return;
-    } else if (isred(p)) { /* 2.3d */
-      single_rotate(s, il);
-      single_rotate(p, !il);
-      setblack(x);
-      setred(s);
-      return;
-    } else {  /* 2.3e */
-      single_rotate(s, il);
-      single_rotate(p, !il);
-      setblack(x);
-      return;
-    }
-  }
-}
-
-
-rb_print_tree(t, level)
-Rb_node t;
-int level;
-{
-  int i;
-  if (ishead(t) && t->p.parent == t) {
-    printf("tree 0x%x is empty\n", t);
-  } else if (ishead(t)) {
-    printf("Head: 0x%x.  Root = 0x%x\n", t, t->p.root);
-    rb_print_tree(t->p.root, 0);
-  } else {
-    if (isext(t)) {
-      for (i = 0; i < level; i++) putchar(' ');
-      printf("Ext node 0x%x: %c,%c: p=0x%x, k=%s\n", 
-              t, isred(t)?'R':'B', isleft(t)?'l':'r', t->p.parent, t->k.key);
-    } else {
-      rb_print_tree(t->c.child.left, level+2);
-      rb_print_tree(t->c.child.right, level+2);
-      for (i = 0; i < level; i++) putchar(' ');
-      printf("Int node 0x%x: %c,%c: l=0x%x, r=0x%x, p=0x%x, lr=(%s,%s)\n", 
-              t, isred(t)?'R':'B', isleft(t)?'l':'r', t->c.child.left, 
-              t->c.child.right, 
-              t->p.parent, t->k.lext->k.key, t->v.rext->k.key);
-    }
-  }
-}
-
-rb_iprint_tree(t, level)
-Rb_node t;
-int level;
-{
-  int i;
-  if (ishead(t) && t->p.parent == t) {
-    printf("tree 0x%x is empty\n", t);
-  } else if (ishead(t)) {
-    printf("Head: 0x%x.  Root = 0x%x, < = 0x%x, > = 0x%x\n", 
-            t, t->p.root, t->c.list.blink, t->c.list.flink);
-    rb_iprint_tree(t->p.root, 0);
-  } else {
-    if (isext(t)) {
-      for (i = 0; i < level; i++) putchar(' ');
-      printf("Ext node 0x%x: %c,%c: p=0x%x, <=0x%x, >=0x%x k=%d\n", 
-              t, isred(t)?'R':'B', isleft(t)?'l':'r', t->p.parent, 
-              t->c.list.blink, t->c.list.flink, t->k.ikey);
-    } else {
-      rb_iprint_tree(t->c.child.left, level+2);
-      rb_iprint_tree(t->c.child.right, level+2);
-      for (i = 0; i < level; i++) putchar(' ');
-      printf("Int node 0x%x: %c,%c: l=0x%x, r=0x%x, p=0x%x, lr=(%d,%d)\n", 
-              t, isred(t)?'R':'B', isleft(t)?'l':'r', t->c.child.left, 
-              t->c.child.right, 
-              t->p.parent, t->k.lext->k.ikey, t->v.rext->k.ikey);
-    }
-  }
-}
-      
-rb_nblack(n)
-Rb_node(n);
-{
-  int nb;
-  if (ishead(n) || isint(n)) {
-    fprintf(stderr, "ERROR: rb_nblack called on a non-external node 0x%x\n",
-            n);
-    exit(1);
-  }
-  nb = 0;
-  while(!ishead(n)) {
-    if (isblack(n)) nb++;
-    n = n->p.parent;
-  }
-  return nb;
-}
-
-rb_plength(n)
-Rb_node(n);
-{
-  int pl;
-  if (ishead(n) || isint(n)) {
-    fprintf(stderr, "ERROR: rb_plength called on a non-external node 0x%x\n",
-            n);
-    exit(1);
-  }
-  pl = 0;
-  while(!ishead(n)) {
-    pl++;
-    n = n->p.parent;
-  }
-  return pl;
-}
-
-rb_free_tree(n)
-Rb_node(n);
-{
-  if (!ishead(n)) {
-    fprintf(stderr, "ERROR: Rb_free_tree called on a non-head node\n");
-    exit(1);
-  }
-
-  while(rb_first(n) != nil(n)) {
-    rb_delete_node(rb_first(n));
-  }
-  free(n);
-}
End of rb.c
echo list.h 1>&2
sed 's/^-//' >'list.h' <<'End of list.h'
-/* 
- * $Source: /a/thud/chalk/homes/moore/src/hence/master/librb/RCS/rb.sh,v $
- * $Revision: 1.1 $
- * $Date: 1992/04/08 05:53:02 $
- * $Author: moore $
- */
-
-/* This is the header file for the list manipulation routines in list.c.
- * Any struct can be turned into a list as long as its first two fields are
- * flink and blink. */
-
-typedef struct list {
-  struct list *flink;
-  struct list *blink;
-} *List;
-
-/* Nil, first, next, and prev are macro expansions for list traversal 
- * primitives. */
-
-#define nil(l) (l)
-#define first(l) (l->flink)
-#define last(l) (l->blink)
-#define next(n) (n->flink)
-#define prev(n) (n->blink)
-
-#define mklist(t) ((t *) make_list (sizeof(t)))
-
-/* These are the routines for manipluating lists */
-
-/* void insert(node list);     Inserts a node to the end of a list */
-/* void delete_item(node);     Deletes an arbitrary node */
-/* List make_list(node_size);  Creates a new list */
-/* List get_node(list);        Allocates a node to be inserted into the list */
-/* void free_node(node, list); Deallocates a node from the list */
-
End of list.h
echo rb.h 1>&2
sed 's/^-//' >'rb.h' <<'End of rb.h'
-typedef struct {
-  unsigned red : 1 ;
-  unsigned internal : 1 ;
-  unsigned left : 1 ;
-  unsigned root : 1 ;
-  unsigned head : 1 ;
-} status;
-
-typedef struct rb_node {
-  union {
-    struct {
-      struct rb_node *flink;
-      struct rb_node *blink;
-    } list;
-    struct {
-      struct rb_node *left;
-      struct rb_node *right;
-    } child;
-  } c;
-  union {
-    struct rb_node *parent;
-    struct rb_node *root;
-  } p;
-  status s;
-  union {
-    int ikey;
-    char *key;
-    struct rb_node *lext;
-  } k;
-  union {
-    char *val;
-    struct rb_node *rext;
-  } v;
-} *Rb_node;
-
-extern Rb_node make_rb();
-extern Rb_node rb_insert_b(/* node, char *key, char *value */);
-
-extern Rb_node rb_find_key(/* tree, char *key */);
-extern Rb_node rb_find_ikey(/* tree, int ikey */);
-extern Rb_node rb_find_gkey(/* tree, char *key, cmpfxn */);
-
-extern Rb_node rb_find_key_n(/* tree, char *key, int *found */);
-extern Rb_node rb_find_ikey_n(/* tree, int ikey, int *found */);
-extern Rb_node rb_find_gkey_n(/* tree, char *key, cmpfxn, int *found */);
-extern rb_delete_node(/* node */);
-extern rb_free_tree(/* node */);  /* Deletes and frees an entire tree */
-
-#define rb_insert_a(n, k, v) rb_insert_b(n->c.list.flink, k, v)
-#define rb_insert(t, k, v) rb_insert_b(rb_find_key(t, k), k, v)
-#define rb_inserti(t, k, v) rb_insert_b(rb_find_ikey(t, k), (char *) k, v)
-#define rb_insertg(t, k, v, f) rb_insert_b(rb_find_gkey(t, k, f), k, v)
-#define rb_first(n) (n->c.list.flink)
-#define rb_last(n) (n->c.list.blink)
-#define rb_next(n) (n->c.list.flink)
-#define rb_prev(n) (n->c.list.blink)
-#define rb_empty(t) (t->c.list.flink == t)
-#ifndef nil
-#define nil(t) (t)
-#endif
-
-#define rb_traverse(ptr, lst) \
-  for(ptr = rb_first(lst); ptr != nil(lst); ptr = rb_next(ptr))
-
End of rb.h
echo makefile 1>&2
sed 's/^-//' >'makefile' <<'End of makefile'
-CFLAGS	=	-g
-
-OBJS = rb.o list.o
-
-MOBJS = main.o $(HOME)/lib/$(ARCH)/librb.a
-
-all: librb.a main
-
-librb.a: $(OBJS)
-	ar ru librb.a $(OBJS)
-	ranlib librb.a
-	mv librb.a $(HOME)/lib/$(ARCH)
-	rm *.o
-
-depend: 
-	makedep .
-
-main: $(MOBJS)
-	$(CC) $(CFLAGS) -o main $(MOBJS)
-
-.c.o:
-	$(CC) -c $(CFLAGS) $*.c
-
-# +mkdep+ 
-list.o: \
-          ./list.h \
-          list.c
-
-main.o: \
-          ./rb.h \
-          main.c
-
-rb.o: \
-          ./rb.h \
-          rb.c
-
End of makefile
echo README 1>&2
sed 's/^-//' >'README' <<'End of README'
-Rb.c, Rb.h, List.h, and list.c are files for doing red-black trees and 
-doubly linked lists, respectively.
-
-Rb.h, Rb.c:
-
-Rb.h contains the typedef for red-black tree structures.  Basically, 
-red-black trees are balanced trees whose external nodes are sorted
-by a key, and connected in a linked list.  The following is how
-you use rb.c and rb.h:
-
-Include rb.h in your source.
-
-Make_rb() returns the head of a red-black tree.  It serves two functions:
-Its p.root pointer points to the root of the red-black tree.  Its 
-c.list.flink and c.list.blink pointers point to the first and last 
-external nodes of the tree.  When the tree is empty, all these pointers
-point to itself.
-
-The external nodes can be traversed in sorted order with their
-c.list.flink and c.list.blink pointers.  The macros rb_first, rb_last,
-rb_next, rb_prev, and rb_traverse can be used to traverse external node lists.
-
-External nodes hold two pieces of information: the key and the value
-(in k.key and v.val, respectively).   The key can be a character 
-string, an integer, or a general pointer.  Val is typed as a character
-pointer, but can be any pointer.  If the key is a character string, 
-then one can insert it, and a value into a tree with rb_insert().  If
-it is an integer, then rb_inserti() should be used.  If it is a general 
-pointer, then rb_insertg() must be used, with a comparison function 
-passed as the fourth argument.  This function takes two keys as arguments,
-and returns a negative value, positive value, or 0, depending on whether
-the first key is less than, greater than or equal to the second.  Thus,
-one could use rb_insertg(t, s, v, strcmp) to insert the value v with 
-a character string s into the tree t.
-
-Rb_find_key(t, k) returns the external node in t whose value is equal
-k or whose value is the smallest value greater than k.  (Here, k is
-a string).  If there is no value greater than or equal to k, then 
-t is returned.  Rb_find_ikey(t,k) works when k is an integer, and 
-Rb_find_gkey(t,k,cmp) works for general pointers.
-
-Rb_find_key_n(t, k, n) is the same as rb_find_key, except that it
-returns whether or not k was found in n (n is an int *).  Rb_find_ikey_n
-and Rb_find_gkey_n are the analogous routines for integer and general
-keys.
-
-Rb_insert_b(e, k, v) makes a new external node with key k and val v, and 
-inserts it before the external node e.  If e is the head of a tree, 
-then the new node is inserted at the end of the external node list.
-If this insertion violates sorted order, no error is flagged.  It is 
-assumed that the user knows what he/she is doing.  Rb_insert_a(e,k,v)
-inserts the new node after e (if e = t, it inserts the new node at the
-beginning of the list).
-
-Rb_insert() is therefore really a combination of Rb_find_key() and
-Rb_insert_b().
-
-Rb_delete_node(e) deletes the external node e from a tree (and thus from 
-the linked list of external nodes).  The node is free'd as well, so
-don't retain pointers to it.
-
-Red-black trees are spiffy because find_key, insert, and delete are all
-done in log(n) time.  Thus, they can be freely used instead of hash-tables,
-with the benifit of having the elements in sorted order at all times, and
-with the guarantee of operations being in log(n) time.
-
-Other routines:
-
-Rb_print_tree() will grossly print out a red-black tree with string keys.
-Rb_iprint_tree() will do the same with trees with integer keys.
-Rb_nblack(e) will report the number of black nodes on the path from external
-  node e to the root.  The path length is less than twice this value.
-Rb_plength(e) reports the length of the path from e to the root.
-
-
-List.c and list.h
-
-These are routines for generic doubly linked lists.  Doubly linked lists
-are any structs whose first two fields are flink and blink pointers.
-Mk_list(t) returns an empty list with the type t.  The empty list is 
-a struct whose flink and blink point to itself.  Insert() and delete_item()
-insert and delete nodes from a lsit -- unlike the rb routines, no allocation
-is done here.  In insert(), the node to be inserted is assumed to be allocated,
-and in delete_item(), the deleted node is not free'd.
-
-Get_node() allocates a node from a node list.  The head element in the linked
-list has info about how big of a node to allocate.  Free_node() deallocates
-a node.  In actuality, free_node doesn't call free, but chains the node onto
-a queue of nodes.  That way, get_node first returns nodes from this queue, 
-and malloc need not be called.  This is quite a possible memory leak.  To
-be safe, you can malloc and free your own nodes, instead of calling get_node()
-and free_node().
-
-List.c and list.h are kind of gross, and should be generally avoided because
-of allocation problems.  Try dlist.c & dlist.h for doubly linked lists which
-are more like the red-black tree structs.
End of README
